#include <stdio.h>
#include "lmp.h"

#define MAX_LONG_LENGTH 64 // Maximal length at base 2 of an integer: 64
#define MAX_FORMAT_BUF  255

/* Format a printf-formatter string */
char * dyn_format (start, value1, value2, end)
const char * start; /* pre string*/
int value1;         /* precision */
int value2;         /* significance */
const char * end;   /* post string */
{
  static char result [MAX_FORMAT_BUF + 1];

  if (value1 != -1 && value2 == -1)
    sprintf (result, "%s%%.%dLf%s", start, value1, end);
  else
    sprintf (result, "%s%%.%dLg%s", start, value2, end);

#ifdef DEBUG
  fprintf (stderr, "(DBG) dyn_format: formatter string is %s\n", result);
#endif

  return result;
}

/* convert a value to a special base, using precision */
char * base2base (b, v, p)
unsigned b; /* output base */
long v;     /* input value */
int p;      /* output precision */
{
  static char result[MAX_LONG_LENGTH + 1];
  char c[36] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  int i = 0;

  result [MAX_LONG_LENGTH] = '\0';

  b = b > 35 ? 35 : b;
  for (i = MAX_LONG_LENGTH - 1; v != 0; i--) {
    result [i] = c[v%b];
    v /= b;
  }

  if (p > -1) {
    for (;i != 0 && p >= MAX_LONG_LENGTH - i; i--)
      result[i] = '0';
    return &result[i+1];
  }
  else if (i != MAX_LONG_LENGTH - 1)
    return &result[i+1];
  else {
    result[i] = '0';
    return &result[MAX_LONG_LENGTH-1];
  }
}
