#include <stdio.h>
#include "lmp.h"

/* stop lmp with a message */
void lmp_stop (msg)
const char * msg; /* stop message */
{
  switch (lmp_proc_error) {
  case LMP_NO_ERROR :
#ifdef DEBUG
    fprintf (stderr, "(DBG) stop: No error.\n");
#endif
    return;
  case LMP_UNKNOWN_OPERATOR:
#ifdef DEBUG
    fprintf (stderr, "(DBG) stop: Unknown operator.\n");
#endif
    fprintf (stderr, "Unknown operator at argument %d: %s\n", lmp_get_arg_num (), msg);
    exit (1);
  default:
#ifdef DEBUG
    fprintf (stderr, "(DBG) stop: Unknown error!\n");
#endif
    fprintf (stderr, "Internal error!\n");
    exit (1);
  }
}

/* stop because of an internal lmp error */
void lmp_error (msg, arg)
const char *msg; /* error message */
int arg;         /* argument that caused the error
		  * relative to the current one
		  */
{
#ifdef DEBUG
  fprintf (stderr, "(DBG) error: ");
#endif
  fprintf (stderr, msg, lmp_get_arg_num () + arg);

  exit (1);
}
