#ifndef __LMPMATH_H
#define __LMPMATH_H

#include <math.h>

#ifdef HAVE_LONG_DOUBLE
# ifdef HAVE_POWL
#  define POW(n,e)     powl (n, e)
# endif
# ifdef HAVE_FMODL
#  define MOD(a,b)     fmodl (a, b)
# endif
# ifdef HAVE_SINL
#  define SIN(a)       sinl (a)
# endif
# ifdef HAVE_COSL
#  define COS(a)       cosl (a)
# endif
# ifdef HAVE_TANL
#  define TAN(a)       tanl (a)
# endif
# ifdef HAVE_ASINL
#  define ARCSIN(a)    asinl (a)
# endif
# ifdef HAVE_ACOSL
#  define ARCCOS(a)    acosl (a)
# endif
# ifdef HAVE_ATANL
#  define ARCTAN(a)    atanl (a)
# endif
# ifdef HAVE_LOGL
#  define LOGN(a)      logl (a)
# endif
# ifdef HAVE_LOG10L
#  define LOG10(a)    log10l (a)
# endif
# ifdef HAVE_EXPL
#  define EXP(a)      expl (a)
# endif
# ifdef HAVE_SQRTL
#  define SQRT(a)     sqrtl (a)
# endif
#endif

#ifndef POW
# warning Use double precision power
# define POW(n,e)    pow (n, e)
#endif
#ifndef MOD
# warning Use double precision modulo
# define MOD(a,b)    fmod (a, b)
#endif

#ifndef SIN
# warning Use double precision sine
# define SIN(a)      sin (a)
#endif
#ifndef COS
# warning Use double precision cosine
# define COS(a)      cos (a)
#endif
#ifndef TAN
# warning Use double precision tangent
# define TAN(a)      tan (a)
#endif
#ifndef ARCSIN
# warning Use double precision arc sine
# define ARCSIN(a)   asin (a)
#endif
#ifndef ARCCOS
# warning Use double precision arc cosine
# define ARCCOS(a)   acos (a)
#endif
#ifndef ARCTAN
# warning Use double precision arc tangent
# define ARCTAN(a)   atan (a)
#endif
#ifndef LOGN
# warning Use double precision logarithm
# define LOGN(a)     log (a)
#endif
#ifndef LOG10
# warning Use double precision dec logarithm
# define LOG10(a)    log10 (a)
#endif
#ifndef EXP
# warning Use double precision exp function
# define EXP(a)      exp (a)
#endif
#ifndef SQRT
# warning Use double precision square root
# define SQRT(a)     sqrt (a)
#endif

#endif
